﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using xserver;

namespace Geometry
{
    class SorterByAngle
    {
        private Location footPoint;

        public SorterByAngle(Location footpoint)
        {
            footPoint = footpoint;
        }

        public int CompareLocations(Location loc1, Location loc2)
        {
            int compareValue;
            double cotanLoc1, cotanLoc2;

            if (footPoint.coordinate.point.y == loc1.coordinate.point.y || (footPoint.coordinate.point.y == loc2.coordinate.point.y))
            {
                if (footPoint.coordinate.point.y == loc1.coordinate.point.y && (footPoint.coordinate.point.y != loc2.coordinate.point.y))
                {
                    compareValue = -1;
                }
                else if (footPoint.coordinate.point.y != loc1.coordinate.point.y && (footPoint.coordinate.point.y == loc2.coordinate.point.y))
                {
                    compareValue = 1;
                }
                else
                {
                    if (loc1.coordinate.point.x < loc2.coordinate.point.x)
                        compareValue = -1;
                    else
                        compareValue = 1;
                }
            }
            else
            {
                cotanLoc1 = cotanWithFoot(loc1);
                cotanLoc2 = cotanWithFoot(loc2);

                if (cotanLoc1 < cotanLoc2)
                    compareValue = -1;
                else
                    compareValue = 1;
            }

            return compareValue;
        }

        private double cotanWithFoot(Location loc)
        {
            return -(loc.coordinate.point.x - footPoint.coordinate.point.x) / (loc.coordinate.point.y - footPoint.coordinate.point.y);
        }
    }
}
